<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TpegDescriptor StructType
 * @subpackage Structs
 */
abstract class TpegDescriptor extends AbstractStructBase
{
    /**
     * The descriptor
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\MultilingualString
     */
    public $descriptor;
    /**
     * The tpegDescriptorExtension
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExtensionType
     */
    public $tpegDescriptorExtension;
    /**
     * Constructor method for TpegDescriptor
     * @uses TpegDescriptor::setDescriptor()
     * @uses TpegDescriptor::setTpegDescriptorExtension()
     * @param \StructType\MultilingualString $descriptor
     * @param \StructType\ExtensionType $tpegDescriptorExtension
     */
    public function __construct(\StructType\MultilingualString $descriptor = null, \StructType\ExtensionType $tpegDescriptorExtension = null)
    {
        $this
            ->setDescriptor($descriptor)
            ->setTpegDescriptorExtension($tpegDescriptorExtension);
    }
    /**
     * Get descriptor value
     * @return \StructType\MultilingualString
     */
    public function getDescriptor()
    {
        return $this->descriptor;
    }
    /**
     * Set descriptor value
     * @param \StructType\MultilingualString $descriptor
     * @return \StructType\TpegDescriptor
     */
    public function setDescriptor(\StructType\MultilingualString $descriptor = null)
    {
        $this->descriptor = $descriptor;
        return $this;
    }
    /**
     * Get tpegDescriptorExtension value
     * @return \StructType\ExtensionType|null
     */
    public function getTpegDescriptorExtension()
    {
        return $this->tpegDescriptorExtension;
    }
    /**
     * Set tpegDescriptorExtension value
     * @param \StructType\ExtensionType $tpegDescriptorExtension
     * @return \StructType\TpegDescriptor
     */
    public function setTpegDescriptorExtension(\StructType\ExtensionType $tpegDescriptorExtension = null)
    {
        $this->tpegDescriptorExtension = $tpegDescriptorExtension;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TpegDescriptor
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
